package be.axi.planner.domain;

import java.util.ArrayList;
import java.util.List;

public class MaintenanceJob {
	private Plane plane;
	
	public MaintenanceJob(Plane aPlane) {
		this.plane = aPlane;
	}
	
	public Plane getPlane() {
		return plane;
	}

	public String getId() {
		return plane.getName();
	}
	
	public int getRequiredTechnicians(){
		return this.plane.getRequiredTechnicians();
	}
	
	public int getDifficulty() {
		return getRequiredTechnicians();
	}

	public List<MaintenanceTask> getTasks() {
		List<MaintenanceTask> tasks = new ArrayList<MaintenanceTask>();
		for (int i = 0; i < getRequiredTechnicians(); i++) {
			tasks.add(newMaintenanceTask(this.getId()+".I#"+i));
		}
		return tasks;
	}
	
	private MaintenanceTask newMaintenanceTask(String id){
		MaintenanceTask task = new MaintenanceTask(this, id);
		return task;
	}
	
}
