package be.axi.planner.domain;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.drools.planner.api.domain.solution.PlanningEntityCollectionProperty;
import org.drools.planner.core.score.buildin.simple.SimpleScore;
import org.drools.planner.core.solution.Solution;


public class MaintenanceSchedule implements Solution<SimpleScore>{

	private SimpleScore score;
	private List<MaintenanceTask> maintenanceTasks;
	//assets
	private List<Period> periods;
	private List<Technician> technicians;
	
	public MaintenanceSchedule cloneSolution() {
		MaintenanceSchedule clone = new MaintenanceSchedule();
        clone.periods = this.periods;
        clone.technicians = this.technicians;
        List<MaintenanceTask> clonedTasks = new ArrayList<MaintenanceTask>(
        		maintenanceTasks.size());
        for (MaintenanceTask task : maintenanceTasks) {
        	MaintenanceTask clonedTask = task.clone();
        	clonedTasks.add(clonedTask);
        }
        clone.maintenanceTasks = clonedTasks;
        clone.score = this.score;
       
        return clone;
	}

	public Collection<? extends Object> getProblemFacts() {
		System.out.println(">>getting problemfacts");
		List<Object> facts = new ArrayList<Object>();
        facts.addAll(periods);
        facts.addAll(technicians);
        // Do not add the planning entity's (projects) because that will be done automatically
        return facts;
	}

	public SimpleScore getScore() {
		return this.score;
	}

	public void setScore(SimpleScore aScore) {
		this.score = aScore;
		if (aScore != null){
		System.out.println("Score set to " + aScore.getScore());
		}
	}

	@PlanningEntityCollectionProperty
	public List<MaintenanceTask> getMaintenanceTasks() {
		System.out.println("getting tasks: #" +maintenanceTasks.size());
		return maintenanceTasks;
	}
	
	public void setMaintenanceTasks(List<MaintenanceTask> aTasks) {
		System.out.println("setting tasks");
		this.maintenanceTasks = aTasks;
	}

	public void setTechnicians(List<Technician> aTechnicians) {
		System.out.println("setting technicians");
		this.technicians = aTechnicians;
	}
	
	public List<Technician> getTechnicians() {
		System.out.println("Getting technicians: #"+technicians.size());
		return technicians;
	}
	
	public List<Period> getPeriods() {
		System.out.println("getting periods");
		return periods;
	}
	
	public void setPeriods(List<Period> periods) {
		this.periods = periods;
	}
}
