package be.axi.planner.solution;

import org.apache.commons.lang.builder.CompareToBuilder;
import org.drools.planner.api.domain.entity.PlanningEntityDifficultyWeightFactory;
import org.drools.planner.core.solution.Solution;

import be.axi.planner.domain.MaintenanceTask;

public class TaskDifficultyWeightFactory implements
		PlanningEntityDifficultyWeightFactory {

	@SuppressWarnings("rawtypes")
	public Comparable createDifficultyWeight(Solution solution,
			Object planningEntity) {
		return new TaskDifficultyWeight((MaintenanceTask) planningEntity);
	}
	
	public static class TaskDifficultyWeight implements Comparable<TaskDifficultyWeight> {

        private final MaintenanceTask task;

        public TaskDifficultyWeight(MaintenanceTask aTask) {
            this.task = aTask;
        }

        public int compareTo(TaskDifficultyWeight other) {
            return new CompareToBuilder()
                    // The more difficult tasks require more inspectors, have more entries in loadMap...
                    .append(other.task.getDifficulty(), task.getDifficulty()) // Decreasing
                    .append(other.task.hashCode(), task.hashCode()) // compare may not be 0 => hashCode will always result in difference
                    .toComparison();
        }

    }

}
